--[[
Script from LtGlloq

The aim of this script is to allow units with unguided weapons to blind fire at night toward an enemy unit near then
or fire in the air where enemy units are in a specific AAA defined area

The goal is to have some fireworks in the sky when enemy units are around. And maybe luckily hit one of them

Multiple behaviors for valid groups with unguided weapons:
-default behavior during day time
-At night time, those groups will still engage like its default behavior if an enemy unit is spotted
-At night time, if no enemy unit is spotted but there is a unit nearby at X time its weapon engagement distance ( default = 2),
then the group will guess this enemy unit position in X second and fire at this point or as close as possible to it if they can.
-At night time, if our group is inside a coalition zone with name starting by RedAAAZone or BlueAAAZone then any enemy air unit
  in this zone will make the all allied valid groups with unguided weapons fire blindly  toward the sky in the mere hope of touching something

Obviously due to the amount of fire groups munitions will be quickly depleted so you should set an ammo car nearby to resupply

If you want to add a unit you just have to put its unitType as key in maxFireAtPointDistance array with the max weapon distance range as value.

If you found any bug, improvement or have a question feel free to ask me !

Glloq

This script would not have been possible without the use of Mist and Moose so thanks a lot for those that make it possible

Current supported units:
-Infantry: "Paratrooper AKS-74", "Infantry AK Ins", "Soldier AK", "Infantry AK", "Infantry AK ver2","Infantry AK ver3",
  "Soldier M249", "Soldier M4", "Soldier M4 GRG", "soldier_mauser98", "soldier_wwii_br_01", "soldier_wwii_us"
-Air Defense: HL_KORD, HL_DSHK, tt_DSHK, tt_KORD, MaxxPro_MRAP, "M45_Quadmount", "ZU-23 Insurgent", "ZU-23 Closed Insurgent", "ZU-23 Emplacement", "ZU-23 Emplacement Closed",
  "Ural-375 ZU-23", "Ural-375 ZU-23 Insurgent", "HL_ZU-23", "tt_ZU-23", "flak30", "flak38", "bofors40", "flak18", "flak36",
  "flak37", "flak41", "M1_37mm", "S-60_Type59_Artillery", "ZSU_57_2", "QF_37_AA", "KS-19"
-Fortifications: none
-Armor: none
-Ship: Can't use ship due to bug https://forum.dcs.world/topic/328525-naval-units-ignore-altitude-for-fire-at-point-task/
  not corrected since April 15, 2022 so I won't count on it some day...
  
--]]

debugTarget = false
debugZone = false
debugAlwaysFireSomewhereAboveInZone = false


blindFireDayTime = false --Set to true if you want blind fire to occurs even during day time. Should be useless since AI can see enemies
fireAtPoint = {} --list telling when a group is firing at point (true) or not (false or nil)
shootingStarted = {} --list telling when a group has start shooting (true) or not (false or nil)
shootingEnded = {} --list telling when a group has stop shooting (true) or not (false or nil)
shootingTime = {} --Time since last shoot for the group
timeSinceLastFireMissionReset = 20 --After this time his elapsed we consider the group has stop firing
timeBetweenCheckBlindFireSomewhereAbove = 5
timeBetweenCheckEnemyUnitsInZone = 5
timeBetweenCheckEnemyUnitsForGroup = 5
timePrediction = 15 --Calculate target position in X seconds
minimumUnitsInZoneToStartFire = 1
maxInfantryRadius = 800
maxFireRangeMultiplicater = 2

local maxFireAtPointDistance = {}
local maxInfantryRatio = 0.4 --0.43 --For some reason Infantry can't shoot right above their head
--Infantry
maxFireAtPointDistance["Paratrooper AKS-74"]= 500
maxFireAtPointDistance["Infantry AK Ins"]= 500
maxFireAtPointDistance["Soldier AK"]= 500
maxFireAtPointDistance["Infantry AK"]= 500
maxFireAtPointDistance["Infantry AK ver2"]= 500
maxFireAtPointDistance["Infantry AK ver3"]= 500
maxFireAtPointDistance["Soldier M249"]= 700
maxFireAtPointDistance["Soldier M4"]= 500
maxFireAtPointDistance["Soldier M4 GRG"]= 500
maxFireAtPointDistance["soldier_mauser98"]= 500
maxFireAtPointDistance["soldier_wwii_br_01"]= 500
maxFireAtPointDistance["soldier_wwii_us"]= 500
--Air Defense
maxFireAtPointDistance["HL_KORD"]= 1200
maxFireAtPointDistance["HL_DSHK"]= 1200
maxFireAtPointDistance["tt_DSHK"]= 1200
maxFireAtPointDistance["tt_KORD"]= 1200
maxFireAtPointDistance["MaxxPro_MRAP"]= 1200
maxFireAtPointDistance["M45_Quadmount"]= 1500
maxFireAtPointDistance["ZU-23 Insurgent"]= 2500
maxFireAtPointDistance["ZU-23 Closed Insurgent"]= 2500
maxFireAtPointDistance["ZU-23 Emplacement"]= 2500
maxFireAtPointDistance["ZU-23 Emplacement Closed"]= 2500
maxFireAtPointDistance["Ural-375 ZU-23"]= 2500
maxFireAtPointDistance["Ural-375 ZU-23 Insurgent"]= 2500
maxFireAtPointDistance["HL_ZU-23"]= 2500
maxFireAtPointDistance["tt_ZU-23"]= 2500
maxFireAtPointDistance["flak30"]= 2500
maxFireAtPointDistance["flak38"]= 2500
maxFireAtPointDistance["bofors40"]= 4000
maxFireAtPointDistance["flak18"]= 5000
maxFireAtPointDistance["flak36"]= 5000
maxFireAtPointDistance["flak37"]= 5000
maxFireAtPointDistance["flak41"]= 5000
maxFireAtPointDistance["M1_37mm"]= 5700
maxFireAtPointDistance["S-60_Type59_Artillery"]= 6000
maxFireAtPointDistance["ZSU_57_2"]= 7000
maxFireAtPointDistance["QF_37_AA"]= 9000
maxFireAtPointDistance["KS-19"]= 20000
--Fortifications
--Armor
--Can't use ship due to bug https://forum.dcs.world/topic/328525-naval-units-ignore-altitude-for-fire-at-point-task/
--Ship
maxFireAtPointDistance["Higgins_boat"]= 1000
maxFireAtPointDistance["speedboat"]= 1000
maxFireAtPointDistance["Schnellboot_type_S130"]= 4000
maxFireAtPointDistance["LST_Mk2"]= 4000
maxFireAtPointDistance["Uboat_VIIC"]= 4000
maxFireAtPointDistance["USS_Samuel_Chase"]= 7000
--maxFireAtPointDistance["P4"]= 1000
--maxFireAtPointDistance["PBR_MKII"]= 1000
--maxFireAtPointDistance["Uboat_VIIC"]= 4000




local aaaEventHandler = {}
function aaaEventHandler:onEvent(event)
  if (world.event.S_EVENT_SHOT  == event.id) then
    local unitName= event.initiator:getName()
    local unit = Unit.getByName(unitName)
    local group = unit:getGroup()
    local groupName = group:getName()
    shootingStarted[groupName] = true
    shootingTime[groupName] = event.time
  elseif (world.event.S_EVENT_SHOOTING_START  == event.id) then
    local unitName= event.initiator:getName()
    local unit = Unit.getByName(unitName)
    local group = unit:getGroup()
    local groupName = group:getName()
    shootingStarted[groupName] = true
    shootingTime[groupName] = event.time
  elseif (world.event.S_EVENT_SHOOTING_END  == event.id) then
    local unitName= event.initiator:getName()
    local unit = Unit.getByName(unitName)
    local group = unit:getGroup()
    local groupName = group:getName()
    --[[
    shootingStarted[groupName] = false
    shootingEnded[groupName] = true
    --Clear task
    local unit = Unit.getByName(unitName)
    local aaaGroup = unit:getGroup()--Group.getByName(unitName)
    aaaGroup:getController():resetTask()
    --]]
  end
end
world.addEventHandler(aaaEventHandler)


function taskFireAtPoint(aaaName, targetCoordinate)
  local aaaGroup = Group.getByName(aaaName)
  if aaaGroup then
    local weaponTypeAuto= 52613349374 --3221225470 -- Any Weapon (AnyBomb + AnyRocket + AnyMissile + Cannons) --1073741822 --AutoDCS

    
    --As long as the target is within firing range it will fire even if radius bring it above range
    -- [[
    local FireMissionTask = {
      id = "ComboTask",
      params = {
        tasks = {
          [1] = {                         --fire at target task
            id = 'ControlledTask', 
            params = { 
              task = {
                id = 'FireAtPoint',
                params = {
                  x = targetCoordinate.x,
                  y = targetCoordinate.z,
                  altitude = targetCoordinate.y,
                  zoneRadius = 300,
                  expendQty = 1,
                  expendQtyEnabled = false,
                  weaponType = weaponTypeAuto,
                  counterbattaryRadius = 0,
                  templateId = "",
                }
              },
              stopCondition = {
                duration = 60,               --stop the task if it cannot be completed in 1 minutes
              },
            },
          },
        },
      },
    }
    -- ]]
    
    aaaGroup:getController():setTask(FireMissionTask)
    
    
    shootingEnded[aaaName] = false
    fireAtPoint[aaaName] = true
  end
end


function isGroupNameDestroyed(groupName)
  local group = Group.getByName(groupName)
  if group == nil then
    return true
  else
    local units = group:getUnits()
    for i,unit in ipairs(units) do
      if unit ~= nil then
        return false
      end
    end
    
    return true
  end
end

function blindFireAtUnit(groupName, posGroup, radius, enemyUnitMoose, distance)
  local targetCoordinate = COORDINATE:New(enemyUnitMoose:GetPointVec3().x, enemyUnitMoose:GetPointVec3().y, enemyUnitMoose:GetPointVec3().z)

  
  local targetHeading = enemyUnitMoose:GetHeading()
  local targetVelocity = enemyUnitMoose:GetVelocityMPS()
  local predictedDistance = targetVelocity * timePrediction          
  local predictedTargetCoordinate = targetCoordinate:Translate(predictedDistance, targetHeading, true, false)
              
  distance = math.abs(((predictedTargetCoordinate.x  - posGroup.x)^2 + (predictedTargetCoordinate.y  - posGroup.y)^2 + (predictedTargetCoordinate.z  - posGroup.z)^2)^(0.5))

  local anglePercentRatio = predictedTargetCoordinate.y / distance
  local infantryFixNeeded = false
  if radius <= maxInfantryRadius and anglePercentRatio > maxInfantryRatio then
    infantryFixNeeded = true
  end
  
  if distance < radius and predictedTargetCoordinate.y < radius and not infantryFixNeeded then
    if debugTarget then
      enemyUnitMoose:FlareRed()
      --enemyUnitMoose:SmokeRed()
    end
    
    --if not shootingStarted and shootingEnded then
    --if shootingEnded[groupName] then
      taskFireAtPoint(groupName, predictedTargetCoordinate) --enemyUnitMoose)--enemyUnit)                
    --end
  else
    --Calculate in range shoot coordinate
    local ratio = (radius / distance) * 0.99
    if predictedTargetCoordinate.y > radius then
      local ratioAlt = (radius / predictedTargetCoordinate.y) * 0.99
      if ratioAlt < ratio then
        ratio = ratioAlt
      end
    end
    
    local zoneCoordinate = COORDINATE:New(posGroup.x, posGroup.y, posGroup.z)
    predictedTargetCoordinate = zoneCoordinate:GetIntermediateCoordinate(predictedTargetCoordinate, ratio)
    
    
    if infantryFixNeeded and ratio > maxInfantryRatio then
      local distance2d = math.abs(((predictedTargetCoordinate.x  - posGroup.x)^2 + (predictedTargetCoordinate.z  - posGroup.z)^2)^(0.5))
      local maxAltitude = distance2d * maxInfantryRatio * 0.99
      if predictedTargetCoordinate.y > maxAltitude then
        predictedTargetCoordinate.y = maxAltitude
      end
    end
    
    if debugTarget then
      enemyUnitMoose:FlareRed()
      --enemyUnitMoose:SmokeRed()
    end
    
    --if not shootingStarted and shootingEnded then
    --if shootingEnded[groupName] then
      taskFireAtPoint(groupName, predictedTargetCoordinate) --enemyUnitMoose)--enemyUnit)                
    --end
  end
end

function checkForEnemyAirborneAroundUnit(groupName, radius, enemyCoalition)
  local group = Group.getByName(groupName)
  local posGroup = group:getUnit(1):getPoint()
    
  local enemyCoalitionGroups = coalition.getGroups(enemyCoalition)

  for i, enemyGroup in pairs(enemyCoalitionGroups) do
    local enemyGroupName = enemyGroup:getName()
    if enemyGroup ~= nil and enemyGroup:isExist() == true then
      local enemyUnits = enemyGroup:getUnits()
      for _i, enemyUnit in pairs(enemyUnits) do
        local enemyUnitName = enemyUnit:getName()
        local unitCategory = enemyUnit:getDesc().category
        
        if unitCategory == Unit.Category.AIRPLANE or unitCategory == Unit.Category.HELICOPTER then
          local enemyUnitMoose= UNIT:FindByName(enemyUnitName)

          local uPos = enemyUnit:getPoint()
          --local distance = math.abs(((uPos.x  - posGroup.x)^2 + (uPos.z  - posGroup.z)^2)^(0.5))
          local distance = math.abs(((uPos.x  - posGroup.x)^2 + (uPos.y  - posGroup.y)^2 +(uPos.z  - posGroup.z)^2)^(0.5))
          
          if ( distance < maxFireRangeMultiplicater * radius ) then
            return true
          end
        end
      end
    end
  end
  
  return false
end

function getGroupFireRadius(groupName)
  local group = Group.getByName(groupName)
  local posGroup = group:getUnit(1):getPoint()
  
  local radius = -1
  
  local units = group:getUnits()
  for _i, unit in pairs(units) do
    local unitType = unit:getTypeName()
    if maxFireAtPointDistance[unitType] ~= nil then
      if radius < 0 or radius > maxFireAtPointDistance[unitType] then
        radius = maxFireAtPointDistance[unitType]
      end
    end
  end
  
  return radius
end

function lookForEnemyUnitsAroundGroup(args)
  local groupName = args.groupName
  local alliedCoalition = args.alliedCoalition
  local enemyCoalition = args.enemyCoalition
  
  if not isGroupNameDestroyed(groupName) then --and shootingEnded[groupName] then
  
    if shootingTime[groupName] ~= nil then
      if shootingTime[groupName] + timeSinceLastFireMissionReset >= timer.getTime() then
        fireAtPoint[groupName] = false
        shootingEnded[groupName] = true
      end
    end
    
    if not shootingEnded[groupName] then
      timer.scheduleFunction(lookForEnemyUnitsAroundGroup, args, timer.getTime() + timeBetweenCheckEnemyUnitsForGroup) --will run the function every X seconds (default = 5) for the entirety of the mission
      return
    end
    
    local group = Group.getByName(groupName)
    local posGroup = group:getUnit(1):getPoint()
    
    local radius = getGroupFireRadius(groupName)
    
   
    
    if radius < 0 then
      return
    end
    
    timer.scheduleFunction(lookForEnemyUnitsAroundGroup, args, timer.getTime() + timeBetweenCheckEnemyUnitsForGroup) --will run the function every X seconds (default = 5)  for the entirety of the mission
   
    
    local zoneCoordinate = COORDINATE:New(posGroup.x, posGroup.y, posGroup.z)
    if debugZone then
      zoneCoordinate:FlareZone( FLARECOLOR.White, 90, 60 )
    end
    
    local enemyCoalitionGroups = coalition.getGroups(enemyCoalition)

    for i, enemyGroup in pairs(enemyCoalitionGroups) do
      local enemyGroupName = enemyGroup:getName()
      if enemyGroup ~= nil and enemyGroup:isExist() == true then
        local enemyUnits = enemyGroup:getUnits()
        for _i, enemyUnit in pairs(enemyUnits) do
          local enemyUnitName = enemyUnit:getName()
          local unitCategory = enemyUnit:getDesc().category
          
          if unitCategory == Unit.Category.AIRPLANE or unitCategory == Unit.Category.HELICOPTER then
            local enemyUnitMoose= UNIT:FindByName(enemyUnitName)

            local uPos = enemyUnit:getPoint()
            --local distance = math.abs(((uPos.x  - posGroup.x)^2 + (uPos.z  - posGroup.z)^2)^(0.5))
            local distance = math.abs(((uPos.x  - posGroup.x)^2 + (uPos.y  - posGroup.y)^2 +(uPos.z  - posGroup.z)^2)^(0.5))
            
            if ( distance < maxFireRangeMultiplicater * radius ) then
              blindFireAtUnit(groupName, posGroup, radius, enemyUnitMoose, distance) 
            end
            
            
            if fireAtPoint[groupName] then
              break
            end
          end
        end
      end
    end
  end
end

function blindFireSomewhereAbove(groupName, repeatFire)
  if not isGroupNameDestroyed(groupName) then --and shootingEnded[groupName] then
  
    if shootingTime[groupName] ~= nil then
      if shootingTime[groupName] + timeSinceLastFireMissionReset >= timer.getTime() then
        fireAtPoint[groupName] = false
        shootingEnded[groupName] = true
      end
    end
    
    if not shootingEnded[groupName] then
      if repeatFire then
        timer.scheduleFunction(blindFireSomewhereAbove, {groupName = groupName, repeatFire = repeatFire}, timer.getTime() + timeBetweenCheckBlindFireSomewhereAbove) --will run the function every X seconds (default = 5) for the entirety of the mission
      end
      return
    end
    
    local group = Group.getByName(groupName)
    local posGroup = group:getUnit(1):getPoint()
    
    local radius = getGroupFireRadius(groupName)
    
    if radius < 0 then
      return
    end
    
    if repeatFire then
      timer.scheduleFunction(blindFireSomewhereAbove, {groupName = groupName, repeatFire = repeatFire}, timer.getTime() + timeBetweenCheckBlindFireSomewhereAbove) --will run the function every X seconds (default = 5) for the entirety of the mission
    end
    
    local groupCoordinate = COORDINATE:New(posGroup.x, posGroup.y, posGroup.z)
    local fireCoordinate = groupCoordinate:GetRandomVec3InRadius(radius * 0.5)
    local distance2D = groupCoordinate:Get2DDistance(fireCoordinate)
    fireCoordinate.y = distance2D * 0.4
    taskFireAtPoint(groupName, fireCoordinate)
    
  end
end

function checkEnemyUnitsInZone(args)
  local zoneName = args.zoneName
  local alliedCoalition = args.alliedCoalition
  local enemyCoalition = args.enemyCoalition
  
  local zone = trigger.misc.getZone(zoneName)
  local zoneCoordinate = COORDINATE:New(zone.point.x, zone.point.y, zone.point.z)
  
  if zoneCoordinate:IsNight() or blindFireDayTime then
    local enemyUnits = mist.makeUnitTable({'['.. getMistCoalitionText(enemyCoalition) ..'][plane][helicopter]'})
    local zone_names = { zoneName }
    local unitsInZone = 0
    local enemyUnitsTable = {}
    if #enemyUnits > 0 then
      for i = 1, #enemyUnits do
        if enemyUnits[i] ~= nil then
          local unit = Unit.getByName(enemyUnits[i])
          if unit then
            enemyUnitsTable[#enemyUnitsTable] = enemyUnits[i]
          end
        end
      end
      unitsInZone = mist.getUnitsInZones(enemyUnitsTable, zone_names, 'cylinder')
    end
    
    if debugAlwaysFireSomewhereAboveInZone or #unitsInZone >= minimumUnitsInZoneToStartFire then
      fireSomewhereAboveInZone(zoneName, alliedCoalition, enemyCoalition)
    end
  end
  
  timer.scheduleFunction(checkEnemyUnitsInZone, args, timer.getTime() + timeBetweenCheckEnemyUnitsInZone) --will run the function every X seconds (default = 5) for the entirety of the mission
end

function fireSomewhereAboveInZone(zoneName, alliedCoalition, enemyCoalition)
  --Can't use ship due to bug https://forum.dcs.world/topic/328525-naval-units-ignore-altitude-for-fire-at-point-task/
  local alliedGroundUnits = mist.makeUnitTable({'['.. getMistCoalitionText(alliedCoalition) ..'][vehicle]'}) --[ship]
  local zone_names = { zoneName }
  local unitsInZone = mist.getUnitsInZones(alliedGroundUnits, zone_names, 'cylinder')
  local groups = {}
  local groupNames = {}
  
  for i = 1, #unitsInZone do -- iterate through the units
    local unitName = unitsInZone[i]:getName()
    local groupName = unitsInZone[i]:getGroup():getName()

    if not groups[groupName] then 
      groups[groupName] = true
      groupNames[#groupNames + 1] = groupName
    end
  end
  
  for i = 1, #groupNames do
    if not checkForEnemyAirborneAroundUnit(groupNames[i], getGroupFireRadius(groupNames[i]), enemyCoalition) then
      blindFireSomewhereAbove(groupNames[i], false)
    end
  end
end

function getMistCoalitionText(alliedCoalition)
  local mistCoalitionText
  if alliedCoalition == coalition.side.RED then
    mistCoalitionText = "red"
  elseif alliedCoalition == coalition.side.BLUE then
    mistCoalitionText = "blue"
  end
  return mistCoalitionText
end

function getAlliedAAAZoneNameTemplate(alliedCoalition)
  local alliedAAAZoneNameTemplate
  if alliedCoalition == coalition.side.RED then
    alliedAAAZoneNameTemplate = "^RedAAAZone"
  elseif alliedCoalition == coalition.side.BLUE then
    alliedAAAZoneNameTemplate = "^BlueAAAZone"
  end
  return alliedAAAZoneNameTemplate
end

function startCoalitionNightAAA(alliedCoalition, enemyCoalition)  
  local alliedCoalitionGroups = coalition.getGroups(alliedCoalition) --getGroups(coalition.side.RED)
  for i = 1, #alliedCoalitionGroups do

    local alliedGroup = alliedCoalitionGroups[i]
    local groupName = alliedGroup:getName()

    shootingStarted[groupName] = false
    shootingEnded[groupName] = true
  
    lookForEnemyUnitsAroundGroup({groupName = groupName, alliedCoalition = alliedCoalition, enemyCoalition = enemyCoalition})
    --blindFireSomewhereAbove(groupName, true)
  end
  
  for zoneName, zoneData in pairs(mist.DBs.zonesByName) do
    if zoneName:find(getAlliedAAAZoneNameTemplate(alliedCoalition)) ~= nil then
      checkEnemyUnitsInZone({zoneName = zoneName, alliedCoalition = alliedCoalition, enemyCoalition = enemyCoalition})
    end 
  end
end

function startBlueNightAAA()
  startCoalitionNightAAA(coalition.side.BLUE, coalition.side.RED)
end

function startRedNightAAA()
  startCoalitionNightAAA(coalition.side.RED, coalition.side.BLUE)
end

function startNightAAA()
  startBlueNightAAA()
  startRedNightAAA()
end

timer.scheduleFunction(startNightAAA, nil, timer.getTime() + 1) --Keep a delay due to issues if we try it at mission start
